package com.zoho.scrapy;


import jdk.nashorn.internal.parser.JSONParser;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONObject;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.concurrent.*;

public class FileDownload {
    public static void main(String[] args) {
//        File f = new File("../APIDATA_FAIL.txt");
//        if (f.exists()) {
//            f.delete();
//            try {
//                f.createNewFile();
//            } catch (IOException e) {
//                throw new RuntimeException(e);
//            }
//        }
        BlockingQueue<Runnable> linkedBlockingDeque = new LinkedBlockingDeque<>(300);
        ExecutorService executorService = new ThreadPoolExecutor(300,300,1000L, TimeUnit.MILLISECONDS,linkedBlockingDeque,new ThreadPoolExecutor.CallerRunsPolicy());
        int id = 3043995;
        while (id < 3100000) {
            executorService.execute(new Worker(id));
            System.out.println(id);
            id += 1;
        }
    }

    public static class Worker implements Runnable{
        int id;
        public Worker(Integer id){
            this.id = id;
        }
        @Override
        public void run() {
            try{
                String targetURL = "https://devapi2.lead411.com/api/v2/guest/company/" + this.id + "/true";
                HttpGet get = new HttpGet(targetURL);
                Client httpClient = new Client();
                try(CloseableHttpClient client = httpClient.getClient()){
                    if(client!=null){
                        try(CloseableHttpResponse response = client.execute(get)){
                            int statusCode = response.getStatusLine().getStatusCode();
                            if(statusCode == 200){
                                HttpEntity entity = response.getEntity();
                                String content = EntityUtils.toString(entity);
                                save(this.id,content);
                            }
                            else{
                                //error 404,429,999,500.
                                addToError(this.id,statusCode);
                            }
                            response.close();
                            client.close();
                        }
                    }
                }
            } catch (Exception  ex) {
                ex.printStackTrace();
            }
        }

        private void save(int id, String content) throws IOException {
            Path path = Paths.get("../APIDATA");
            Files.createDirectories(path);
            File file = new File("../APIDATA/"+id+".html");
            if(!file.exists() && file.delete()){
                System.out.println("Deleted existed file ::" + file.getName());
            }
            PrintWriter writer = new PrintWriter(file,"UTF-8");
            Document doc = Jsoup.parse(content);
            writer.write(doc.html());
            writer.flush();
            writer.close();
        }

        private synchronized void addToError(int id, int status_code) throws IOException {
            BufferedWriter writer = new BufferedWriter(new FileWriter("../APIDATA_FAIL.txt", true));
            writer.write(id + " :: " + status_code);
            writer.newLine();
            writer.close();
        }
    }
}
