package com.zoho.scrapy;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.sql.SQLException;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.Set;
import java.util.concurrent.*;

/**
 * @author sumanth-13934
 */
public class Main {
    public static final String lock = Main.class.getName();
    public static final Set<Object> cmpnyNameSet = Collections.synchronizedSet(new LinkedHashSet<>());
    public static ConcurrentLinkedQueue<HashMap<String, String>> urlsQueue = new ConcurrentLinkedQueue<>();
    public static void main(String[] args) throws IOException, InterruptedException, SQLException, ClassNotFoundException {

        //Service -> load names into DB
        //Thread insertIntoDb = new Thread(new PopulateInDB(Config.urlsFile));
        //insertIntoDb.start();
        //Thread.sleep(1500);

        //sync insert into DB
        PopulateDBSync populateDBSync = new PopulateDBSync(Config.urlsFile);
        populateDBSync.populate();

        //service -> load into process queue.
        Thread feedThread = new Thread(new QueueFeed(urlsQueue));
        //feedThread.setDaemon(true);
        feedThread.start();
        Thread.sleep(2000L);

        //service -> save html pages.
        BlockingQueue<Runnable> linkedBlockingDeque = new LinkedBlockingDeque<>(Config.Threads);
        ExecutorService executorService = new ThreadPoolExecutor(Config.Threads,Config.Threads,1000L, TimeUnit.MILLISECONDS,linkedBlockingDeque,new ThreadPoolExecutor.CallerRunsPolicy());
        try{
            while (true){
                if(urlsQueue.size() > 0 ){
                    HashMap<String, String> temp;
                    synchronized (lock) {
                        temp = urlsQueue.peek();
                        urlsQueue.remove();
                    }
                    executorService.execute(new Worker(temp));
                }
            }
        }
        catch(Exception e){
            e.printStackTrace();
            StringWriter sw = new StringWriter();
            e.printStackTrace(new PrintWriter(sw));
            String exceptionAsString = sw.toString();
            ErrorLog.log(exceptionAsString);
            e.printStackTrace();
            executorService.shutdown();
        }
    }
}
