package com.zoho.scrapy;

import java.io.*;
import java.sql.*;
import java.util.HashSet;

/**
 * @author sumanth-13934
 */
public class PopulateInDB implements Runnable{

    private static FileReader reader;
    private static int batchSize = 1000;
    private static long count = 0;

    public PopulateInDB(String fileName) throws FileNotFoundException {
        reader = new FileReader(fileName);
    }

    @Override
    public void run(){
        try{
            DBConnection dbConnection = new DBConnection();
            Connection conn = dbConnection.getDBConnection();
            DatabaseMetaData databaseMetaData = conn.getMetaData();;
            ResultSet resultSet = databaseMetaData.getTables(null,null,null, new String[] {"TABLE"});
            HashSet<String> tables = new HashSet<>();
            while (resultSet.next()){
                tables.add(resultSet.getString("TABLE_NAME"));
            }

            //Creating Table to populate company names in table.
            if(!tables.contains("lcmpydb")){
                Statement createTableSmt = conn.createStatement();
                String createLCmpyDb = "CREATE TABLE lcmpydb("+
                        "id BIGSERIAL PRIMARY KEY,"+
                        "cmpy TEXT,"+
                        "statuscode SMALLINT,"+
                        "started BIGINT,"+
                        "ended BIGINT,"+
                        "retry SMALLINT,"+
                        "status SMALLINT"+
                        ");";
                if(createTableSmt.executeUpdate(createLCmpyDb) == 0){
                    System.out.println("created lcmpydb table...");
                }
                else {
                    System.out.println("Error occurred while creating lcmpydb table...");
                }
            }
            else {
                System.out.println("lcmpydb table already existed...");
            }

            //populating into table.
            if(Config.forceInsertInToDB){
                System.out.println("Inserting to db...");
                long start = System.currentTimeMillis();
                BufferedReader bufferedReader = new BufferedReader(reader);
                String line;
                String insertQuery = "insert into lcmpydb values(DEFAULT,?,?,?,?,?,?);";
                PreparedStatement insertPSmt = conn.prepareStatement(insertQuery);
                while((line=bufferedReader.readLine()) != null){
                    String temp  = line.replace("'", "\\'");
                    String findQuery = "select count(*) from lcmpydb where cmpy=E'"+temp+"';";
                    Statement findSmt = conn.createStatement();
                    ResultSet findRS = findSmt.executeQuery(findQuery);
                    findRS.next();
                    int rowCount = Integer.parseInt(findRS.getString(1));
                    if(rowCount == 0){
                        count += 1;
                        insertPSmt.setString(1,line);
                        insertPSmt.setInt(2,0);
                        insertPSmt.setInt(3,0);
                        insertPSmt.setInt(4,0);
                        insertPSmt.setInt(5,0);
                        insertPSmt.setInt(6,2);
                        insertPSmt.addBatch();
                        if(count % batchSize == 0){
                            insertPSmt.executeBatch();
                        }
                    }
                    findRS.close();
                    findSmt.close();
                }
                if(count % batchSize != 0){
                    insertPSmt.executeBatch();
                }
                insertPSmt.close();
                long end = System.currentTimeMillis();
                double total = (end-start)/1000.0;
                System.out.println("Inserted all records in "+total+" sec.");

            }
            else {
                System.out.println("Force insert into table is Disabled,no data while insert into table...");
            }
            conn.close();
        }
        catch (Exception e){
            e.printStackTrace();
        }
    }
}
