package com.zoho.scrapy;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;

/**
 * @author sumanth-13934
 */
public class QueueFeed implements Runnable{
    private static ConcurrentLinkedQueue<HashMap<String, String>> queue;
    private static boolean starting = true;
    private long startTime = 0L;
    private long currentTime = 0L;
    private static final long retryInterval = Config.retryInterval * 1000L ;

    private static Connection conn;

    public QueueFeed(ConcurrentLinkedQueue<HashMap<String, String>> q) throws SQLException, ClassNotFoundException {
        queue = q;
        DBConnection dbConnection = new DBConnection();
        conn = dbConnection.getDBConnection();
    }

    @Override
    public void run() {
        String LOCK = QueueFeed.class.getName();
        try{
            //initial pick -> which is in queue state.
            if(starting){
                starting = false;
                String startQuery = "select * from lcmpydb where status = 1;";
                Statement selectSmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
                ResultSet selectRs = selectSmt.executeQuery(startQuery);
                while(selectRs.next()){
                    HashMap<String, String> temp = new HashMap<>();
                    temp.put("id", String.valueOf(selectRs.getLong("id")));
                    temp.put("name",selectRs.getString("cmpy"));
                    System.out.println(temp);
                    queue.add(temp);
                }
                selectRs.close();
                selectSmt.close();
            }
            while (true){
                if(queue.size() <= Config.queueSize){
                    System.out.println("Entering For Queue Process");
                    currentTime = System.currentTimeMillis();
                    if(currentTime - startTime >= retryInterval){
                        startTime = currentTime;
                        String selectQuery = "select * from lcmpydb where statuscode!=200 and statuscode!=404 and retry between 1 and 2 and status = 2;";
                        Statement selectSmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
                        ResultSet selectRs = selectSmt.executeQuery(selectQuery);
                        while (selectRs.next()){
                            HashMap<String, String> temp = new HashMap<>();
                            temp.put("id", String.valueOf(selectRs.getLong("id")));
                            temp.put("name",selectRs.getString("cmpy"));
                            System.out.println(temp);
                            synchronized (LOCK) {
                                queue.add(temp);
                                selectRs.updateInt("status",1);
                                selectRs.updateRow();
                            }
                        }
                        selectRs.close();
                        selectSmt.close();
                    }
                    else{
                        String selectQuery = "select * from lcmpydb where status = 2 and statuscode!=404 and retry = 0 limit "+Config.batchLimit+ ";";
                        System.out.println(selectQuery);
                        Statement selectSmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
                        ResultSet selectRs = selectSmt.executeQuery(selectQuery);
                        while(selectRs.next()){
                            HashMap<String, String> temp = new HashMap<>();
                            temp.put("id", String.valueOf(selectRs.getLong("id")));
                            temp.put("name",selectRs.getString("cmpy"));
                            synchronized (LOCK){
                                queue.add(temp);
                                selectRs.updateInt("status",1);
                                selectRs.updateRow();
                            }
                        }
                        selectRs.close();
                        selectSmt.close();
                    }
                }
                else {
                    Thread.sleep(1000);
                }
            }
        }
        catch (Exception e){
            e.printStackTrace();
        }
        finally {
            try {
                conn.close();
            } catch (SQLException e) {
                throw new RuntimeException(e);
            }
        }
    }
}
