package com.zoho.scrapy;

import org.apache.http.HttpEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.util.EntityUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.*;
import java.net.InetAddress;
import java.net.URLEncoder;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.sql.*;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.Set;

/**
 * @author sumanth-13934
 */
public class Worker implements Runnable{

    private String cmpyName;
    private long id;
    private static final String baseurl = "https://www.linkedin.com/organization-guest/";
    public Worker(HashMap<String, String> qData){
        this.cmpyName = qData.get("name");
        this.id = Long.parseLong(qData.get("id"));
    }
    static String LOCK = Worker.class.getName();
    String nonStaticLock = Worker.class.getName();


    @Override
    public void run() {
        try {
            Thread.sleep(1000L);
            String cmpyName = this.cmpyName;
            String targetURL = null;
            if(!cmpyName.contains("linkedin.com")) {
                targetURL = baseurl + cmpyName;
            } else {
                targetURL = cmpyName;

            }
//            System.out.println(targetURL);
//            String targetURL = "https://www.webshare.io/";
            long start = System.currentTimeMillis();
            targetURL = new URIBuilder().setPath(targetURL).toString();
            targetURL = targetURL.substring(1);
            System.out.println("nI am tarer "+targetURL);
            HttpGet get = new HttpGet(targetURL);
            Client httpClient = new Client();
            try(CloseableHttpClient client = httpClient.getClient()){
                if(client!=null){
                    try(CloseableHttpResponse response = client.execute(get)){
                        int statusCode = response.getStatusLine().getStatusCode();
                        if(statusCode == 200){
                            HttpEntity entity = response.getEntity();
                            String html = EntityUtils.toString(entity);
                            Elements elements = Jsoup.parse(html).select("a[href*=similar-pages]");
                            if(elements.size()>0) {
                                checkAddToDb(elements);
                            }
                            save(cmpyName,html);
                            long end = System.currentTimeMillis();
                            updateRow(this.id,statusCode,start,end);
                        }
                        else{
                            System.out.println(response);
                            //error 404,429,999,500.
                            updateRow(this.id,statusCode);
                        }
                        response.close();
                        client.close();
                    }
                }
            }

        } catch (SQLException | IOException | ClassNotFoundException | InterruptedException e) {
            try {
                updateRow(this.id, 0);
                ErrorLog.log(this.cmpyName+"::"+e.toString());
            } catch (IOException | SQLException | ClassNotFoundException ex) {
                throw new RuntimeException(ex);
            }
        }
    }

    private void checkAddToDb(Elements elements) {
        Set<String> cmpnyNameSet = new LinkedHashSet<>();
        for(Element element:elements) {
            String url = element.attr("href");
            if(url.contains("company/")) {
                String cmpname = url.replaceFirst(".*company/","").replaceAll("\\?trk=similar-pages", "");
                cmpname="company/"+cmpname;
                cmpnyNameSet.add(cmpname);
//                insertRow(cmpname);
            } else if(url.contains("school/")) {
                String cmpname = url.replaceFirst(".*school/","").replaceAll("/?trk=similar-pages", "");
                cmpname="school/"+cmpname;
                cmpnyNameSet.add(cmpname);
//                insertRow(cmpname);
            }else if(url.contains("showcase/")) {
                String cmpname = url.replaceFirst(".*showcase/","").replaceAll("/?trk=similar-pages", "");
                cmpname="showcase/"+cmpname;
                cmpnyNameSet.add(cmpname);
//                insertRow(cmpname);
            } else {
                System.out.println("similar url not in syntax  "+url);
                String cmpname = url.split("school/")[1].replaceAll("/?trk=similar-pages", "");
                System.out.println("Not inserter Similar page Not in struct " + cmpname);
                try {
                    ErrorLog.log("Not inserted Similar page Not in struct  " + cmpname);
                }catch (Exception ex) {
                    throw new RuntimeException(ex);
                }
            }
        }
        if(elements.size() > 0) {
            insertBatchUpdate(cmpnyNameSet);
        }
    }

    private void updateRow(long id, int statusCode, long started, long ended) throws SQLException, ClassNotFoundException {
        synchronized (nonStaticLock) {
            DBConnection dbConnection = new DBConnection();
            Connection conn = dbConnection.getDBConnection();
            String startQuery = "select * from lcmpydb where id=" + id + ";";
            Statement selectSmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
            ResultSet rs = selectSmt.executeQuery(startQuery);
            rs.next();
            rs.updateInt("statuscode", statusCode);
            rs.updateLong("started", started);
            rs.updateLong("ended", ended);
            int retry = rs.getInt("retry") + 1;
            rs.updateInt("retry", retry);
            rs.updateInt("status", 0);
            rs.updateRow();
            rs.close();
            conn.close();
        }
    }

    public static boolean insertRow(String cmpyN)  {
        try {
            synchronized (LOCK) {
                DBConnection dbConnection = new DBConnection();
                Connection conn = dbConnection.getDBConnection();
                if (cmpyN.contains("\'")) {
                    cmpyN = cmpyN.replaceAll("\'", "\'\'");
                }
//                String startQuery = "select * from lcmpydb where cmpy='" + cmpyN + "';";
//                Statement selectSmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
//                ResultSet rs = selectSmt.executeQuery(startQuery);
//                if (rs.next()) {
//                    rs.close();
//                    conn.close();
//                    return false;
//                } else {
                cmpyN = cmpyN.replaceAll("\'\'", "\'");
                String insertQuery = "insert into lcmpydb values(DEFAULT,?,?,?,?,?,?) on conflict(cmpy) do nothing;";
                PreparedStatement insertPSmt = conn.prepareStatement(insertQuery);
                insertPSmt.setString(1, cmpyN);
                insertPSmt.setInt(2, 0);
                insertPSmt.setInt(3, 0);
                insertPSmt.setInt(4, 0);
                insertPSmt.setInt(5, 0);
                insertPSmt.setInt(6, 2);
                insertPSmt.addBatch();
                insertPSmt.executeBatch();
                insertPSmt.close();
                conn.close();
                return true;
//                }
            }
        } catch(Exception e){
            e.printStackTrace();
            try {
                ErrorLog.log(cmpyN + ":: Not inserted");
            } catch (IOException ex) {
                throw new RuntimeException(ex);
            }
        }


        return false;
    }

    public static boolean insertBatchUpdate(Set<String> cmpyNSet)  {
        try {
            synchronized (LOCK) {
                DBConnection dbConnection = new DBConnection();
                Connection conn = dbConnection.getDBConnection();
//                long starttime = System.currentTimeMillis();
                String insertQuery = "insert into similarcmpy values(DEFAULT,?,?) on conflict(cmpy) do nothing;";
                PreparedStatement insertPSmt = conn.prepareStatement(insertQuery);
                for(String cmpyN:cmpyNSet){
                    insertPSmt.setString(1,cmpyN);
                    insertPSmt.setInt(2,cmpyN.hashCode());
                    insertPSmt.addBatch();
                }
                insertPSmt.executeBatch();
                insertPSmt.close();
                conn.close();
//                System.out.println("Over all time taken " + (starttime-System.currentTimeMillis()));
//                System.exit(9);
            }
        } catch(Exception e){
            e.printStackTrace();
            try {
                ErrorLog.log(cmpyNSet + ":: Not inserted");
            } catch (IOException ex) {
                throw new RuntimeException(ex);
            }
        }


        return false;
    }

    private  void updateRow(long id, int statusCode) throws SQLException, ClassNotFoundException {
        synchronized (nonStaticLock) {
            DBConnection dbConnection = new DBConnection();
            Connection conn = dbConnection.getDBConnection();
            String startQuery = "select * from lcmpydb where id=" + id + ";";
            Statement selectSmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);
            ResultSet rs = selectSmt.executeQuery(startQuery);
            rs.next();
            int retry = rs.getInt("retry") + 1;
            rs.updateInt("retry", retry);
            rs.updateInt("statuscode", statusCode);
            rs.updateInt("status", 2);
            rs.updateRow();
            rs.close();
            conn.close();
        }
    }

    private static void save(String cmyName, String html) throws IOException {
        Path path = Paths.get(Config.dataSavePath+"batch"+Config.batchNo+"/data");
        Files.createDirectories(path);
        if(cmyName.contains("/")) {
            cmyName = cmyName.split("/")[1];
        }
        File file = new File(Config.dataSavePath+"batch"+Config.batchNo+"/data/"+cmyName+".html");
        if (!file.exists() && file.delete()) {
            System.out.println("Deleted existed file ::" + file.getName());
        }
        PrintWriter writer = new PrintWriter(file,"UTF-8");
        Document doc = Jsoup.parse(html);
        writer.write(doc.html());
        writer.flush();
        writer.close();
    }
}
